/*
 * File:  BitWise.cc
 * Author:  mikolas
 * Created on:  Wed Aug 1 16:32:00 WEST 2012
 * Copyright (C) 2012, Mikolas Janota
 */
#include "BitWise.hh"
using std::ostream; 
void BitWise::encode() {
  const size_t n    = vars.size();
  const size_t logn = aux.size();
  for (size_t i=0; i<n; ++i) {
    const Lit nv=~mkLit(v(i));
    size_t val=i;
    for (size_t j=0; j<logn; ++j) {
      addClause(nv, (val & 1) ? mkLit(b(j)) : ~mkLit(b(j)));
      val>>=1;
    }    
  }

  const size_t ub = 1<<logn;
  for (size_t i=n; i<ub; ++i) {
    vector<Lit>& cl=addClause();
    size_t val=i;
    for (size_t j=0; j<logn; ++j) {
      cl.push_back( (val & 1) ? ~mkLit(b(j)) : mkLit(b(j)) );
      val>>=1;
    }
  }
}

void BitWise::initialize() {
  size_t vs=vars.size();
  while (vs) {
    aux.push_back(++max_id);
    vs>>=1;
  }
}


