/*
 * File:  ReadPartial.cc
 * Author:  mikolas
 * Created on:  Sun, Aug 12, 2012 4:56:28 PM
 * Copyright (C) 2012, Mikolas Janota
 */
#include "ReadPartial.hh"
using namespace Mifumax;

void ReadPartial::parse_clause() {
  const WeightType w = is_weighted ? parse_weight(in) : 1;
  if (w==1) {
    read_cnf_clause_into(soft_clauses);
  } else {
    if (!is_partial || w!=top) {
      throw ReadCNFException("a weight different from 1 and top found");
    }  
    read_cnf_clause_into(hard_clauses);
  }
}

ReadPartial::ReadPartial(Reader& input_file) : ReadWCNFBase(input_file)
{}

ReadPartial::ReadPartial(const ReadPartial& orig)
: ReadWCNFBase(orig)
{assert(false);}


ReadPartial::~ReadPartial() {}
