/*
 * File:  ReadWeighted.cc
 * Author:  mikolas
 * Created on:  Sun, Aug 12, 2012 4:56:41 PM
 * Copyright (C) 2012, Mikolas Janota
 */
#include "ReadWeighted.hh"
using namespace Mifumax;
void ReadWeighted::parse_clause() {
  const WeightType w = is_weighted ? parse_weight(in) : 1;
  if (is_partial && (w==top)) {
    read_cnf_clause_into(hard_clauses);
  } else { 
    const size_t sz=soft_clauses.size();
    soft_clauses.resize(sz+1);
    soft_clauses[sz].first=w;
    read_cnf_clause(soft_clauses[sz].second, in, mxid);
  }
}

ReadWeighted::ReadWeighted(Reader& input_file) 
: ReadWCNFBase(input_file)
{}

ReadWeighted::ReadWeighted(const ReadWeighted& orig)
: ReadWCNFBase(orig)
{assert(false);}


ReadWeighted::~ReadWeighted() {}
