/*
 * File:  ReadWeighted.hh
 * Author:  mikolas
 * Created on:  Sun, Aug 12, 2012 4:56:44 PM
 * Copyright (C) 2012, Mikolas Janota
 */
#ifndef READWEIGHTED_HH_8469
#define READWEIGHTED_HH_8469
#include "ReadWCNFBase.hh"
namespace Mifumax {
  class ReadWeighted : public ReadWCNFBase {
  public:
    ReadWeighted(Reader& input_file);
    ReadWeighted(const ReadWeighted& orig);
    virtual ~ReadWeighted();
    const ClauseVector&          get_hard_clause_vector() const  {return hard_clauses;}
    const WeightedClauseVector&  get_soft_clause_vector() const  {return soft_clauses;}
  private:
    WeightedClauseVector      soft_clauses;
    ClauseVector              hard_clauses;
    virtual void              parse_clause();
  };
};
#endif /* READWEIGHTED_HH_8469 */
