/*
 * File:  SeqCounter.cc
 * Author:  mikolas
 * Created on:  Thu Dec 1 16:19:34 GMTST 2011
 * Copyright (C) 2011, Mikolas Janota
 */
#include "SeqCounter.hh"
using std::ostream; 
void SeqCounter::encode() {
  const size_t n = vars.size();
  if (tval==0) { encode_all0(); return; }
  if (tval >= n) return;

  assert(n>1);

  addClause(~mkLit(v(1)), mkLit(s(1, 1)));       
  for(size_t j=2;j<=tval; ++j)  addClause(~mkLit(s(1, j)));

  for(size_t i=2;i<n; ++i) {
    addClause(~mkLit(v(i)), mkLit(s(i, 1)));
    addClause(~mkLit(s(i-1, 1)), mkLit(s(i, 1)));

    for(size_t j=2;j<=tval;++j) {
      addClause(~mkLit(v(i)), ~mkLit(s(i-1, j-1)), mkLit(s(i, j)));
      addClause(~mkLit(s(i-1, j)), mkLit(s(i, j)));
    }
    addClause(~mkLit(v(i)), ~mkLit(s(i-1, tval)));
  }
  addClause(~mkLit(v(n)), ~mkLit(s(n-1, tval)));
}

void SeqCounter::encode_all0() {
  const size_t n = vars.size();
  for(size_t i=1;i<=n; ++i) addClause(~mkLit(v(i)));
}



